# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class SystemService(Model):
    """Information about a system service deployed in the cluster.

    :param system_service_type: The system service type. Possible values
     include: 'None', 'ScoringFrontEnd', 'BatchFrontEnd'
    :type system_service_type: str or :class:`SystemServiceType
     <azure.mgmt.machinelearningcompute.models.SystemServiceType>`
    :param public_ip_address: The public IP address of the system service
    :type public_ip_address: str
    :param version: The state of the system service
    :type version: str
    """

    _validation = {
        'system_service_type': {'required': True},
        'public_ip_address': {'required': True},
        'version': {'required': True},
    }

    _attribute_map = {
        'system_service_type': {'key': 'systemServiceType', 'type': 'str'},
        'public_ip_address': {'key': 'publicIpAddress', 'type': 'str'},
        'version': {'key': 'version', 'type': 'str'},
    }

    def __init__(self, system_service_type, public_ip_address, version):
        self.system_service_type = system_service_type
        self.public_ip_address = public_ip_address
        self.version = version
